# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

try:
    from ._models_py3 import AzureEntityResource
    from ._models_py3 import BackupRequest
    from ._models_py3 import CheckNameAvailabilityParameters
    from ._models_py3 import CheckNameAvailabilityResult
    from ._models_py3 import CloudEndpoint
    from ._models_py3 import CloudEndpointCreateParameters
    from ._models_py3 import OperationDisplayInfo
    from ._models_py3 import OperationDisplayResource
    from ._models_py3 import OperationEntity
    from ._models_py3 import OperationStatus
    from ._models_py3 import PostBackupResponse
    from ._models_py3 import PostRestoreRequest
    from ._models_py3 import PreRestoreRequest
    from ._models_py3 import ProxyResource
    from ._models_py3 import RecallActionParameters
    from ._models_py3 import RegisteredServer
    from ._models_py3 import RegisteredServerCreateParameters
    from ._models_py3 import Resource
    from ._models_py3 import ResourcesMoveInfo
    from ._models_py3 import RestoreFileSpec
    from ._models_py3 import ServerEndpoint
    from ._models_py3 import ServerEndpointCloudTieringStatus
    from ._models_py3 import ServerEndpointCreateParameters
    from ._models_py3 import ServerEndpointFilesNotSyncingError
    from ._models_py3 import ServerEndpointRecallError
    from ._models_py3 import ServerEndpointRecallStatus
    from ._models_py3 import ServerEndpointSyncActivityStatus
    from ._models_py3 import ServerEndpointSyncSessionStatus
    from ._models_py3 import ServerEndpointSyncStatus
    from ._models_py3 import ServerEndpointUpdateParameters
    from ._models_py3 import StorageSyncApiError
    from ._models_py3 import StorageSyncError, StorageSyncErrorException
    from ._models_py3 import StorageSyncErrorDetails
    from ._models_py3 import StorageSyncService
    from ._models_py3 import StorageSyncServiceCreateParameters
    from ._models_py3 import StorageSyncServiceUpdateParameters
    from ._models_py3 import SubscriptionState
    from ._models_py3 import SyncGroup
    from ._models_py3 import SyncGroupCreateParameters
    from ._models_py3 import TrackedResource
    from ._models_py3 import TriggerChangeDetectionParameters
    from ._models_py3 import TriggerRolloverRequest
    from ._models_py3 import Workflow
except (SyntaxError, ImportError):
    from ._models import AzureEntityResource
    from ._models import BackupRequest
    from ._models import CheckNameAvailabilityParameters
    from ._models import CheckNameAvailabilityResult
    from ._models import CloudEndpoint
    from ._models import CloudEndpointCreateParameters
    from ._models import OperationDisplayInfo
    from ._models import OperationDisplayResource
    from ._models import OperationEntity
    from ._models import OperationStatus
    from ._models import PostBackupResponse
    from ._models import PostRestoreRequest
    from ._models import PreRestoreRequest
    from ._models import ProxyResource
    from ._models import RecallActionParameters
    from ._models import RegisteredServer
    from ._models import RegisteredServerCreateParameters
    from ._models import Resource
    from ._models import ResourcesMoveInfo
    from ._models import RestoreFileSpec
    from ._models import ServerEndpoint
    from ._models import ServerEndpointCloudTieringStatus
    from ._models import ServerEndpointCreateParameters
    from ._models import ServerEndpointFilesNotSyncingError
    from ._models import ServerEndpointRecallError
    from ._models import ServerEndpointRecallStatus
    from ._models import ServerEndpointSyncActivityStatus
    from ._models import ServerEndpointSyncSessionStatus
    from ._models import ServerEndpointSyncStatus
    from ._models import ServerEndpointUpdateParameters
    from ._models import StorageSyncApiError
    from ._models import StorageSyncError, StorageSyncErrorException
    from ._models import StorageSyncErrorDetails
    from ._models import StorageSyncService
    from ._models import StorageSyncServiceCreateParameters
    from ._models import StorageSyncServiceUpdateParameters
    from ._models import SubscriptionState
    from ._models import SyncGroup
    from ._models import SyncGroupCreateParameters
    from ._models import TrackedResource
    from ._models import TriggerChangeDetectionParameters
    from ._models import TriggerRolloverRequest
    from ._models import Workflow
from ._paged_models import CloudEndpointPaged
from ._paged_models import OperationEntityPaged
from ._paged_models import RegisteredServerPaged
from ._paged_models import ServerEndpointPaged
from ._paged_models import StorageSyncServicePaged
from ._paged_models import SyncGroupPaged
from ._paged_models import WorkflowPaged
from ._storage_sync_management_client_enums import (
    Reason,
    ChangeDetectionMode,
    NameAvailabilityReason,
)

__all__ = [
    'AzureEntityResource',
    'BackupRequest',
    'CheckNameAvailabilityParameters',
    'CheckNameAvailabilityResult',
    'CloudEndpoint',
    'CloudEndpointCreateParameters',
    'OperationDisplayInfo',
    'OperationDisplayResource',
    'OperationEntity',
    'OperationStatus',
    'PostBackupResponse',
    'PostRestoreRequest',
    'PreRestoreRequest',
    'ProxyResource',
    'RecallActionParameters',
    'RegisteredServer',
    'RegisteredServerCreateParameters',
    'Resource',
    'ResourcesMoveInfo',
    'RestoreFileSpec',
    'ServerEndpoint',
    'ServerEndpointCloudTieringStatus',
    'ServerEndpointCreateParameters',
    'ServerEndpointFilesNotSyncingError',
    'ServerEndpointRecallError',
    'ServerEndpointRecallStatus',
    'ServerEndpointSyncActivityStatus',
    'ServerEndpointSyncSessionStatus',
    'ServerEndpointSyncStatus',
    'ServerEndpointUpdateParameters',
    'StorageSyncApiError',
    'StorageSyncError', 'StorageSyncErrorException',
    'StorageSyncErrorDetails',
    'StorageSyncService',
    'StorageSyncServiceCreateParameters',
    'StorageSyncServiceUpdateParameters',
    'SubscriptionState',
    'SyncGroup',
    'SyncGroupCreateParameters',
    'TrackedResource',
    'TriggerChangeDetectionParameters',
    'TriggerRolloverRequest',
    'Workflow',
    'OperationEntityPaged',
    'StorageSyncServicePaged',
    'SyncGroupPaged',
    'CloudEndpointPaged',
    'ServerEndpointPaged',
    'RegisteredServerPaged',
    'WorkflowPaged',
    'Reason',
    'ChangeDetectionMode',
    'NameAvailabilityReason',
]
