# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.paging import Paged


class OperationPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Operation <azure.mgmt.support.models.Operation>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Operation]'}
    }

    def __init__(self, *args, **kwargs):

        super(OperationPaged, self).__init__(*args, **kwargs)
class ServicePaged(Paged):
    """
    A paging container for iterating over a list of :class:`Service <azure.mgmt.support.models.Service>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Service]'}
    }

    def __init__(self, *args, **kwargs):

        super(ServicePaged, self).__init__(*args, **kwargs)
class ProblemClassificationPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ProblemClassification <azure.mgmt.support.models.ProblemClassification>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ProblemClassification]'}
    }

    def __init__(self, *args, **kwargs):

        super(ProblemClassificationPaged, self).__init__(*args, **kwargs)
class SupportTicketDetailsPaged(Paged):
    """
    A paging container for iterating over a list of :class:`SupportTicketDetails <azure.mgmt.support.models.SupportTicketDetails>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SupportTicketDetails]'}
    }

    def __init__(self, *args, **kwargs):

        super(SupportTicketDetailsPaged, self).__init__(*args, **kwargs)
class CommunicationDetailsPaged(Paged):
    """
    A paging container for iterating over a list of :class:`CommunicationDetails <azure.mgmt.support.models.CommunicationDetails>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[CommunicationDetails]'}
    }

    def __init__(self, *args, **kwargs):

        super(CommunicationDetailsPaged, self).__init__(*args, **kwargs)
